///////////////////////////////////////////////////////////////////////
// sysex.h :	Defines the sys_EX class
//	

#ifndef __SYSEX_H_INCLUDED__
#define __SYSEX_H_INCLUDED__


#ifdef SYSEX_INC_COMDEF
#include <comdef.h>
#endif

#ifdef _INC_COMDEF
#define SYSEX_E_COMERROR MAKE_HRESULT(SEVERITY_ERROR,FACILITY_ITF,0xFFFE)
#endif

///////////////////////////////////////////////////////////////////////
// external variables

extern HINSTANCE g_hMODInstance;	// from within a DLL server set this to 
											// hInstance in DLLMain

///////////////////////////////////////////////////////////////////////
// Retrieve text for GetLastError() or HRESULT code

LPCTSTR GetLastErrorText(DWORD dwError);

///////////////////////////////////////////////////////////////////////
// class sys_EX

class sys_EX
{
// Attributes
private:
	DWORD m_dwError;
	LPTSTR m_pszSource;
	LPTSTR m_pszDescription;
	TCHAR  m_szSYSError[512];

public:
	DWORD	  GetError();
	LPCTSTR GetSource();
	LPCTSTR GetErrorString();
	LPCTSTR GetDescription();

// Implementation		
public:
	sys_EX(const sys_EX& o);
	sys_EX(int nSourceLine,char* pszSourceFile);
	sys_EX& operator=(const sys_EX& o);
  ~sys_EX();

// Operations
public:
	void Display(HWND hWndParent=NULL);
	void SetError(DWORD dwError);
	void SetDescription(LPCTSTR pszFmt,...);	

// COM
#ifdef _INC_COMDEF
	void		set_com_error(_com_error& e);
	HRESULT	raise_com_error(REFGUID rguid);
#endif 

};

#define CONSTRUCT_SYSEX(ex) sys_EX ex(__LINE__,__FILE__)

#define SYSEX_THROW(dwErr)				\
	{	sys_EX ex(__LINE__,__FILE__);	\
		ex.SetError((dwErr));			\
		throw ex;	}

#define SYSEX_TRY() try {
#define SYSEX_CATCH_THROW() } catch(...) { throw; }

#endif // __SYSEX_H_INCLUDED__